commit 8c208a877d30b53a11d9caa0a49fad899201f4fa
Author: freddy77 <freddy77>
Date:   Wed May 12 08:15:27 2010 +0000

    fix and improve fakepoll for Windows

diff --git a/ChangeLog b/ChangeLog
index 1823424..689b4b0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed May 12 10:15:04 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/fakepoll.h src/replacements/fakepoll.c:
+	- fix and improve fakepoll for Windows
+
 Wed May 12 10:13:17 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds_sysdep_private.h: fix minor issue with MingW
 
@@ -2438,4 +2442,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3020 2010/05/12 08:13:58 freddy77 Exp $
+$Id: ChangeLog,v 1.3021 2010/05/12 08:15:27 freddy77 Exp $
diff --git a/include/fakepoll.h b/include/fakepoll.h
index 74cd7d4..5b77fde 100644
--- a/include/fakepoll.h
+++ b/include/fakepoll.h
@@ -1,4 +1,4 @@
-/* $Id: fakepoll.h,v 1.3 2010/01/10 14:43:11 freddy77 Exp $ */
+/* $Id: fakepoll.h,v 1.4 2010/05/12 08:15:27 freddy77 Exp $ */
 #if !defined(_FAKE_POLL_H) && !defined(HAVE_POLL)
 #define _FAKE_POLL_H
 
@@ -30,29 +30,49 @@
 #define FD_SETSIZE OPEN_MAX
 #endif
 
-// poll flags
-#define POLLIN  0x0001
-#define POLLOUT 0x0004
-#define POLLERR 0x0008
+#ifndef _WIN32
+/* poll flags */
+# define POLLIN  0x0001
+# define POLLOUT 0x0004
+# define POLLERR 0x0008
 
-// synonyms
-#define POLLNORM POLLIN
-#define POLLPRI POLLIN
-#define POLLRDNORM POLLIN
-#define POLLRDBAND POLLIN
-#define POLLWRNORM POLLOUT
-#define POLLWRBAND POLLOUT
-
-// ignored
-#define POLLHUP 0x0010
-#define POLLNVAL 0x0020
+/* synonyms */
+# define POLLNORM POLLIN
+# define POLLPRI POLLIN
+# define POLLRDNORM POLLIN
+# define POLLRDBAND POLLIN
+# define POLLWRNORM POLLOUT
+# define POLLWRBAND POLLOUT
 
+/* ignored */
+# define POLLHUP 0x0010
+# define POLLNVAL 0x0020
 typedef struct pollfd {
     int fd;		/* file descriptor to poll */
     short events;	/* events of interest on fd */
     short revents;	/* events that occurred on fd */
 } pollfd_t;
 
+#else /* Windows */
+/*
+ * Windows use different constants then Unix
+ * Newer version have a WSAPoll which is equal to Unix poll
+ */
+# if !defined(POLLRDNORM) && !defined(POLLWRNORM)
+#  define POLLIN  0x0300
+#  define POLLOUT 0x0010
+#  define POLLERR 0x0001
+#  define POLLRDNORM 0x0100
+#  define POLLWRNORM 0x0010
+typedef struct pollfd {
+    SOCKET fd;	/* file descriptor to poll */
+    short events;	/* events of interest on fd */
+    short revents;	/* events that occurred on fd */
+} pollfd_t;
+# else
+typedef struct pollfd pollfd_t;
+# endif
+#endif
 
 int fakepoll(struct pollfd fds[], int nfds, int timeout);
 
diff --git a/src/replacements/fakepoll.c b/src/replacements/fakepoll.c
index 3899c2b..81cc5ce 100644
--- a/src/replacements/fakepoll.c
+++ b/src/replacements/fakepoll.c
@@ -23,7 +23,7 @@
 
 #ifndef HAVE_POLL
 
-static char software_version[] = "$Id: fakepoll.c,v 1.8 2010/01/10 14:43:11 freddy77 Exp $";
+static char software_version[] = "$Id: fakepoll.c,v 1.9 2010/05/12 08:15:27 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #include <stdarg.h>
@@ -68,6 +68,22 @@ fakepoll(struct pollfd fds[], int nfds, int timeout)
 	const struct pollfd *endp = fds? fds + nfds : NULL;
 	int selected, polled = 0, maxfd = 0;
 
+#if defined(_WIN32)
+	typedef int WSAAPI (*WSAPoll_t)(struct pollfd fds[], ULONG nfds, INT timeout);
+	static WSAPoll_t poll_p = (WSAPoll_t) -1;
+	if (poll_p == (WSAPoll_t) -1) {
+		HMODULE mod;
+
+		poll_p = NULL;
+		mod = GetModuleHandle("ws2_32");
+		if (mod)
+			poll_p = (WSAPoll_t) GetProcAddress(mod, "WSAPoll");
+	}
+	/* Windows 2008 have WSAPoll which is semantically equal to poll */
+	if (poll_p != NULL)
+		return poll_p(fds, nfds, timeout);
+#endif
+
 	if (fds == NULL) {
 		errno = EFAULT;
 		return -1;

